import { EventEmitter, Component, ChangeDetectionStrategy, Input, Output, ViewChildren, forwardRef, ChangeDetectorRef, ComponentFactoryResolver, ContentChildren, HostBinding, ViewChild, ViewContainerRef, NgModule } from '@angular/core';
import { ReactiveFormsModule } from '@angular/forms';
import { DynamicFormControlComponent, DynamicFormLayoutService, DynamicFormValidationService, DynamicFormGroupComponent, DynamicFormControlContainerComponent, DynamicFormComponentService, DynamicFormRelationService, DynamicTemplateDirective, DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA, DYNAMIC_FORM_CONTROL_TYPE_SWITCH, DYNAMIC_FORM_CONTROL_TYPE_SELECT, DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP, DYNAMIC_FORM_CONTROL_TYPE_INPUT, DYNAMIC_FORM_CONTROL_TYPE_GROUP, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX, DYNAMIC_FORM_CONTROL_TYPE_ARRAY, DynamicFormArrayComponent, DynamicFormComponent, DynamicFormsCoreModule } from '@ng-dynamic-forms/core';
import { CommonModule } from '@angular/common';
import { TextMaskModule } from 'angular2-text-mask';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationCheckboxComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationCheckboxComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-checkbox",
                template: "<label [formGroup]=\"group\">\n\n    <input type=\"checkbox\"\n           [checked]=\"model.checked\"\n           [formControlName]=\"model.id\"\n           [id]=\"id\"\n           [indeterminate]=\"model.indeterminate\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [required]=\"model.required\"\n           [tabindex]=\"model.tabIndex\"\n           [value]=\"model.value\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/><span [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"\n                                            [innerHTML]=\"model.label\"></span></label>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationCheckboxComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationCheckboxComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationCheckboxComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationCheckboxComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationCheckboxComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationCheckboxComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationCheckboxComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationCheckboxComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationCheckboxComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationCheckboxComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationCheckboxComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationTextAreaComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationTextAreaComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-textarea",
                template: "<ng-container [formGroup]=\"group\">\n\n    <textarea [class.is-invalid-input]=\"showErrorMessages\"\n              [cols]=\"model.cols\"\n              [formControlName]=\"model.id\"\n              [id]=\"id\"\n              [maxlength]=\"model.maxLength\"\n              [minlength]=\"model.minLength\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\"\n              [placeholder]=\"model.placeholder\"\n              [readonly]=\"model.readOnly\"\n              [required]=\"model.required\"\n              [rows]=\"model.rows\"\n              [spellcheck]=\"model.spellCheck\"\n              [tabindex]=\"model.tabIndex\"\n              [wrap]=\"model.wrap\"\n              (blur)=\"onBlur($event)\"\n              (change)=\"onChange($event)\"\n              (focus)=\"onFocus($event)\"></textarea>\n\n</ng-container>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationTextAreaComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationTextAreaComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationTextAreaComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationTextAreaComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationTextAreaComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationTextAreaComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationTextAreaComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationTextAreaComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationTextAreaComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationTextAreaComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationTextAreaComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationSwitchComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationSwitchComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-switch",
                template: "<div [formGroup]=\"group\" class=\"switch\" [ngClass]=\"getClass('element', 'control')\">\n\n    <input type=\"checkbox\" class=\"switch-input\"\n           [checked]=\"model.checked\"\n           [formControlName]=\"model.id\"\n           [id]=\"id\"\n           [name]=\"model.name\"\n           [required]=\"model.required\"\n           [tabindex]=\"model.tabIndex\"\n           [value]=\"model.value\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/>\n\n    <label class=\"switch-paddle\" [for]=\"id\">\n\n        <span class=\"switch-active\" aria-hidden=\"true\">{{ model.onLabel }}</span>\n        <span class=\"switch-inactive\" aria-hidden=\"true\">{{ model.offLabel }}</span>\n\n    </label>\n\n</div>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationSwitchComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationSwitchComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationSwitchComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationSwitchComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationSwitchComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationSwitchComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationSwitchComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationSwitchComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationSwitchComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationSwitchComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationSwitchComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationSelectComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationSelectComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-select",
                template: "<ng-container [formGroup]=\"group\">\n\n    <select [compareWith]=\"model.compareWithFn\"\n            [formControlName]=\"model.id\"\n            [id]=\"id\"\n            [name]=\"model.name\"\n            [ngClass]=\"getClass('element', 'control')\"\n            [required]=\"model.required\"\n            [tabindex]=\"model.tabIndex\"\n            (blur)=\"onBlur($event)\"\n            (change)=\"onChange($event)\"\n            (focus)=\"onFocus($event)\">\n\n        <option *ngFor=\"let option of model.options$ | async\"\n                [disabled]=\"option.disabled\"\n                [ngValue]=\"option.value\">{{ option.label }}\n        </option>\n\n    </select>\n\n</ng-container>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationSelectComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationSelectComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationSelectComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationSelectComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationSelectComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationSelectComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationSelectComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationSelectComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationSelectComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationSelectComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationSelectComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationRadioGroupComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationRadioGroupComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-radio-group",
                template: "<fieldset role=\"radiogroup\"\n          [formGroup]=\"group\"\n          [id]=\"id\"\n          [name]=\"model.name\"\n          [ngClass]=\"getClass('element', 'control')\"\n          [tabindex]=\"model.tabIndex\"\n          (change)=\"onChange($event)\">\n\n    <legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend>\n\n    <label *ngFor=\"let option of model.options$ | async\" [ngClass]=\"getClass('element', 'option')\">\n\n        <input type=\"radio\"\n               [formControlName]=\"model.id\"\n               [name]=\"model.name\"\n               [value]=\"option.value\"\n               (blur)=\"onBlur($event)\"\n               (focus)=\"onFocus($event)\"/><span [innerHTML]=\"option.label\"></span></label>\n\n</fieldset>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationRadioGroupComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationRadioGroupComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationRadioGroupComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationRadioGroupComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationRadioGroupComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationRadioGroupComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationRadioGroupComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationRadioGroupComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationRadioGroupComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationRadioGroupComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationRadioGroupComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationInputComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationInputComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-input",
                template: "<div [formGroup]=\"group\" class=\"input-group\">\n\n    <span *ngIf=\"model.prefix\" class=\"input-group-label\" [innerHTML]=\"model.prefix\"></span>\n\n    <input class=\"input-group-field\"\n           [attr.accept]=\"model.accept\"\n           [attr.max]=\"model.max\"\n           [attr.min]=\"model.min\"\n           [attr.multiple]=\"model.multiple\"\n           [attr.step]=\"model.step\"\n           [autocomplete]=\"model.autoComplete\"\n           [autofocus]=\"model.autoFocus\"\n           [class.is-invalid-input]=\"showErrorMessages\"\n           [dynamicList]=\"model.listId\"\n           [formControlName]=\"model.id\"\n           [id]=\"id\"\n           [maxlength]=\"model.maxLength\"\n           [minlength]=\"model.minLength\"\n           [name]=\"model.name\"\n           [ngClass]=\"getClass('element', 'control')\"\n           [pattern]=\"model.pattern\"\n           [placeholder]=\"model.placeholder\"\n           [readonly]=\"model.readOnly\"\n           [required]=\"model.required\"\n           [spellcheck]=\"model.spellCheck\"\n           [tabindex]=\"model.tabIndex\"\n           [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\"\n           [type]=\"model.inputType\"\n           (blur)=\"onBlur($event)\"\n           (change)=\"onChange($event)\"\n           (focus)=\"onFocus($event)\"/>\n\n    <span *ngIf=\"model.suffix\" class=\"input-group-label\" [innerHTML]=\"model.suffix\"></span>\n\n    <datalist *ngIf=\"model.hasList\" [id]=\"model.listId\">\n\n        <option *ngFor=\"let option of model.list$ | async\" [value]=\"option\">\n\n    </datalist>\n\n</div>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationInputComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationInputComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationInputComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationInputComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationInputComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationInputComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationInputComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationInputComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationInputComponent.prototype.focus;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationInputComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationInputComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationFormGroupComponent extends DynamicFormGroupComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.customEvent = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationFormGroupComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-form-group",
                template: "<ng-container [formGroup]=\"group\">\n\n    <fieldset [formGroupName]=\"model.id\"\n              [id]=\"id\"\n              [name]=\"model.name\"\n              [ngClass]=\"getClass('element', 'control')\">\n\n        <legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend>\n\n        <dynamic-foundation-form-control *ngFor=\"let _model of model.group\"\n                                         [group]=\"control\"\n                                         [hidden]=\"_model.hidden\"\n                                         [layout]=\"formLayout\"\n                                         [model]=\"_model\"\n                                         [templates]=\"templates\"\n                                         [hostClass]=\"[getClass('element','children'), getClass('grid','children')]\"\n                                         (blur)=\"onBlur($event)\"\n                                         (change)=\"onChange($event)\"\n                                         (focus)=\"onFocus($event)\"\n                                         (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-foundation-form-control>\n    </fieldset>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicFoundationFormGroupComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationFormGroupComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    templates: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    customEvent: [{ type: Output }],
    focus: [{ type: Output }],
    components: [{ type: ViewChildren, args: [forwardRef((/**
                 * @return {?}
                 */
                () => DynamicFoundationFormControlContainerComponent)),] }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.templates;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.customEvent;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.focus;
    /** @type {?} */
    DynamicFoundationFormGroupComponent.prototype.components;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormGroupComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormGroupComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationFormControlContainerComponent extends DynamicFormControlContainerComponent {
    /**
     * @param {?} changeDetectorRef
     * @param {?} componentFactoryResolver
     * @param {?} layoutService
     * @param {?} validationService
     * @param {?} componentService
     * @param {?} relationService
     */
    constructor(changeDetectorRef, componentFactoryResolver, layoutService, validationService, componentService, relationService) {
        super(changeDetectorRef, componentFactoryResolver, layoutService, validationService, componentService, relationService);
        this.changeDetectorRef = changeDetectorRef;
        this.componentFactoryResolver = componentFactoryResolver;
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.componentService = componentService;
        this.relationService = relationService;
        this.context = null;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
    /**
     * @return {?}
     */
    get componentType() {
        return this.componentService.getCustomComponentType(this.model) || foundationUIFormControlMapFn(this.model);
    }
}
DynamicFoundationFormControlContainerComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-form-control",
                template: "<div [formGroup]=\"group\"\n     [ngClass]=\"['ng-dynamic-forms-'+model.type.toLowerCase(), getClass('element', 'container'), getClass('grid', 'container')]\">\n\n    <div *ngIf=\"!isCheckbox && hasLabel\" [ngClass]=\"getClass('grid', 'label')\">\n\n        <label [class.is-invalid-label]=\"showErrorMessages\"\n               [for]=\"id\"\n               [innerHTML]=\"model.label\"\n               [ngClass]=\"getClass('element', 'label')\"></label>\n    </div>\n\n    <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: model\"></ng-container>\n\n    <div [ngClass]=\"getClass('grid', 'control')\">\n\n        <ng-container #componentViewContainer></ng-container>\n\n    </div>\n\n    <ul *ngIf=\"showErrorMessages\" [ngClass]=\"[getClass('element', 'errors'), getClass('grid', 'errors')]\">\n        <li *ngFor=\"let message of errorMessages\" class=\"form-error is-visible\">{{ message }}</li>\n    </ul>\n\n    <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: model\"></ng-container>\n\n    <ng-content></ng-content>\n\n</div>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationFormControlContainerComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: ComponentFactoryResolver },
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService },
    { type: DynamicFormComponentService },
    { type: DynamicFormRelationService }
];
DynamicFoundationFormControlContainerComponent.propDecorators = {
    contentTemplateList: [{ type: ContentChildren, args: [DynamicTemplateDirective,] }],
    klass: [{ type: HostBinding, args: ["class",] }],
    context: [{ type: Input }],
    group: [{ type: Input }],
    hostClass: [{ type: Input }],
    inputTemplateList: [{ type: Input, args: ["templates",] }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }],
    componentViewContainerRef: [{ type: ViewChild, args: ["componentViewContainer", { read: ViewContainerRef, static: true },] }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.contentTemplateList;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.klass;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.context;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.hostClass;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.inputTemplateList;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.focus;
    /** @type {?} */
    DynamicFoundationFormControlContainerComponent.prototype.componentViewContainerRef;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormControlContainerComponent.prototype.changeDetectorRef;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormControlContainerComponent.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormControlContainerComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormControlContainerComponent.prototype.validationService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormControlContainerComponent.prototype.componentService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormControlContainerComponent.prototype.relationService;
}
/**
 * @param {?} model
 * @return {?}
 */
function foundationUIFormControlMapFn(model) {
    switch (model.type) {
        case DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
            return DynamicFoundationFormArrayComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
            return DynamicFoundationCheckboxComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            return DynamicFoundationFormGroupComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_GROUP:
            return DynamicFoundationFormGroupComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_INPUT:
            return DynamicFoundationInputComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
            return DynamicFoundationRadioGroupComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_SELECT:
            return DynamicFoundationSelectComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_SWITCH:
            return DynamicFoundationSwitchComponent;
        case DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
            return DynamicFoundationTextAreaComponent;
        default:
            return null;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationFormArrayComponent extends DynamicFormArrayComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     */
    constructor(layoutService, validationService) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.customEvent = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationFormArrayComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-form-array",
                template: "<ng-container [formGroup]=\"group\">\n\n    <div [formArrayName]=\"model.id\" [id]=\"id\" [ngClass]=\"getClass('element', 'control')\">\n\n        <div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\"\n             [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\">\n\n            <ng-container *ngTemplateOutlet=\"startTemplate?.templateRef; context: groupModel\"></ng-container>\n\n            <dynamic-foundation-form-control *ngFor=\"let _model of groupModel.group\"\n                                             [context]=\"groupModel\"\n                                             [group]=\"array.at(idx)\"\n                                             [hidden]=\"_model.hidden\"\n                                             [layout]=\"formLayout\"\n                                             [model]=\"_model\"\n                                             [templates]=\"templates\"\n                                             [hostClass]=\"[getClass('element','children'), getClass('grid','children')]\"\n                                             (blur)=\"onBlur($event)\"\n                                             (change)=\"onChange($event)\"\n                                             (focus)=\"onFocus($event)\"\n                                             (bsEvent)=\"onCustomEvent($event, null, true)\"></dynamic-foundation-form-control>\n\n            <ng-container *ngTemplateOutlet=\"endTemplate?.templateRef; context: groupModel\"></ng-container>\n\n        </div>\n\n    </div>\n\n</ng-container>\n"
            }] }
];
/** @nocollapse */
DynamicFoundationFormArrayComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService }
];
DynamicFoundationFormArrayComponent.propDecorators = {
    formLayout: [{ type: Input }],
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    templates: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    customEvent: [{ type: Output }],
    focus: [{ type: Output }],
    components: [{ type: ViewChildren, args: [forwardRef((/**
                 * @return {?}
                 */
                () => DynamicFoundationFormControlContainerComponent)),] }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.formLayout;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.templates;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.customEvent;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.focus;
    /** @type {?} */
    DynamicFoundationFormArrayComponent.prototype.components;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormArrayComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormArrayComponent.prototype.validationService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFoundationFormComponent extends DynamicFormComponent {
    /**
     * @param {?} changeDetectorRef
     * @param {?} componentService
     */
    constructor(changeDetectorRef, componentService) {
        super(changeDetectorRef, componentService);
        this.changeDetectorRef = changeDetectorRef;
        this.componentService = componentService;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicFoundationFormComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-foundation-form",
                template: "<dynamic-foundation-form-control *ngFor=\"let controlModel of model; trackBy: trackByFn\"\n                                 [group]=\"group\"\n                                 [hidden]=\"controlModel.hidden\"\n                                 [layout]=\"layout\"\n                                 [model]=\"controlModel\"\n                                 [templates]=\"templates\"\n                                 (blur)=\"onBlur($event)\"\n                                 (change)=\"onChange($event)\"\n                                 (focus)=\"onFocus($event)\"></dynamic-foundation-form-control>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicFoundationFormComponent.ctorParameters = () => [
    { type: ChangeDetectorRef },
    { type: DynamicFormComponentService }
];
DynamicFoundationFormComponent.propDecorators = {
    group: [{ type: Input }],
    model: [{ type: Input }],
    layout: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }],
    templates: [{ type: ContentChildren, args: [DynamicTemplateDirective,] }],
    components: [{ type: ViewChildren, args: [DynamicFoundationFormControlContainerComponent,] }]
};
if (false) {
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.group;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.model;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.layout;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.blur;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.change;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.focus;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.templates;
    /** @type {?} */
    DynamicFoundationFormComponent.prototype.components;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormComponent.prototype.changeDetectorRef;
    /**
     * @type {?}
     * @protected
     */
    DynamicFoundationFormComponent.prototype.componentService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DynamicFormsFoundationUIModule {
}
DynamicFormsFoundationUIModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    ReactiveFormsModule,
                    TextMaskModule,
                    DynamicFormsCoreModule
                ],
                declarations: [
                    DynamicFoundationCheckboxComponent,
                    DynamicFoundationFormArrayComponent,
                    DynamicFoundationFormComponent,
                    DynamicFoundationFormControlContainerComponent,
                    DynamicFoundationFormGroupComponent,
                    DynamicFoundationInputComponent,
                    DynamicFoundationRadioGroupComponent,
                    DynamicFoundationSelectComponent,
                    DynamicFoundationSwitchComponent,
                    DynamicFoundationTextAreaComponent
                ],
                entryComponents: [
                    DynamicFoundationCheckboxComponent,
                    DynamicFoundationFormArrayComponent,
                    DynamicFoundationFormGroupComponent,
                    DynamicFoundationInputComponent,
                    DynamicFoundationRadioGroupComponent,
                    DynamicFoundationSelectComponent,
                    DynamicFoundationSwitchComponent,
                    DynamicFoundationTextAreaComponent
                ],
                exports: [
                    DynamicFormsCoreModule,
                    DynamicFoundationCheckboxComponent,
                    DynamicFoundationFormArrayComponent,
                    DynamicFoundationFormComponent,
                    DynamicFoundationFormControlContainerComponent,
                    DynamicFoundationFormGroupComponent,
                    DynamicFoundationInputComponent,
                    DynamicFoundationRadioGroupComponent,
                    DynamicFoundationSelectComponent,
                    DynamicFoundationSwitchComponent,
                    DynamicFoundationTextAreaComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DynamicFormsFoundationUIModule, DynamicFoundationCheckboxComponent, DynamicFoundationFormArrayComponent, DynamicFoundationFormComponent, DynamicFoundationFormControlContainerComponent, DynamicFoundationFormGroupComponent, DynamicFoundationInputComponent, DynamicFoundationRadioGroupComponent, DynamicFoundationSelectComponent, DynamicFoundationSwitchComponent, DynamicFoundationTextAreaComponent, foundationUIFormControlMapFn };
//# sourceMappingURL=ui-foundation.js.map
